/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_COMMON_Common_Defines_STUB_DEFAULT_HPP_
#define V1_COMMONAPI_TELUX_COMMON_Common_Defines_STUB_DEFAULT_HPP_


#include <CommonAPI/Export.hpp>

#include <v1/commonapi/telux/common/CommonDefinesStub.hpp>
#include <cassert>
#include <sstream>

# if defined(_MSC_VER)
#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif
# endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace common {

/**
 * Provides a default implementation for CommonDefinesStubRemoteEvent and
 * CommonDefinesStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class COMMONAPI_EXPORT_CLASS_EXPLICIT CommonDefinesStubDefault
    : public virtual CommonDefinesStub {
public:
    COMMONAPI_EXPORT CommonDefinesStubDefault()
        : remoteEventHandler_(this),
          interfaceVersion_(CommonDefines::getInterfaceVersion()) {
    }

    COMMONAPI_EXPORT const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return interfaceVersion_;
    }

    COMMONAPI_EXPORT CommonDefinesStubRemoteEvent* initStubAdapter(const std::shared_ptr< CommonDefinesStubAdapter> &_adapter) {
        CommonAPI::Stub<CommonDefinesStubAdapter, CommonDefinesStubRemoteEvent>::stubAdapter_ = _adapter;
        return &remoteEventHandler_;
    }



protected:
    class COMMONAPI_EXPORT_CLASS_EXPLICIT RemoteEventHandler: public virtual CommonDefinesStubRemoteEvent {
    public:
        COMMONAPI_EXPORT RemoteEventHandler(CommonDefinesStubDefault *_defaultStub)
            : 
              defaultStub_(_defaultStub) {
        }


    private:
        CommonDefinesStubDefault *defaultStub_;
    };
protected:
    CommonDefinesStubDefault::RemoteEventHandler remoteEventHandler_;

private:


    CommonAPI::Version interfaceVersion_;
};

} // namespace common
} // namespace telux
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_COMMON_Common_Defines_STUB_DEFAULT
